/* Interpreter symbol table and language procedure definitions. */

#include <stdio.h>
#include "idecls.h"
int  abrt,bufp ;
char scall[20] = { 'k', 'i', ' ', '<' } ;
char nbuf[128] ;
struct table_entry symtab[STSIZE] ;
extern pv_ptr clause();

/* Language procedure definitions. */

/* do loop. Supports both forms (do n and do i=n,m ) */

pv_ptr doproc(p)
register pv_ptr p ;
{
	pv_ptr localp, newp ;
	entry_ptr cvar ;
	int typ, val,max,i ;
	newp = clause (p, &typ, &val) ;
	switch ( typ )
	{
	case CONST:
		max = val ;
		localp = newp ;
		for (i=0; i<max && abrt == NORMAL; i++)
		{
			p = localp ;
			newp = clause(p, &typ, &val) ;
		}
		break ;
	case VARIABLE:
		cvar = *p ;
		newp = clause(newp, &typ, &val) ;
		localp = clause(newp, &typ, &max) ;
		for ((*cvar).uval.value=val; (*cvar).uval.value <= max
			&& abrt == NORMAL; ++(*cvar).uval.value)
		{
			p = localp ;
			newp = clause(p, &typ, &val) ;
		}
		break ;
	}
	return(newp) ;
}

/* 'begin' / 'end' capability */

pv_ptr begin ( p )
register pv_ptr p ;
{
	int typ, val ;
	while(*p != NULL && abrt == NORMAL && (**p).type != ENDST)
		p = clause (p, &typ, &val) ;
	return (p) ;
}

/* execute interpreter, taking input from file "fname" */

pv_ptr ixeq (p) 
register pv_ptr p ;
{
	register pv_ptr newp ;
	register char *ep ;
	char *iparse();
	entry_ptr localpv[100] ;
	int t,v,len,next ;
	FILE *fp, *fopen() ;
	extern line[],iexec(), getline() ;
	newp = clause (p, &t, &v) ;
	if ((fp=fopen((**p).name,"r"))==NULL)
	{
		fprintf(stderr,"Can't open %s.\n",(**p).name) ;
		abrt = IABORT ;
		return(newp);
	}
	while (abrt == NORMAL)
	{
		if ((len=getline(fp,line,MAXLINE))==EOF) break ;
		if (len==MAXLINE)
		{
			fprintf(stderr,"Line in file %s too long.\n",(**p).name) ;
			abrt == IABORT ;
			break ;
		}
		if ((ep=iparse(line,localpv,&next)) != NULL)
		{
			fprintf (stderr,"%s",ep) ;
			abrt = IABORT ;
			break ;
		}
		localpv[next] = NULL ;
		iexec(localpv) ;
	}
	fclose(fp) ;
	return (newp) ;
}

/* execute system call for "command" */

pv_ptr isys (p)
register pv_ptr p ;
{
	register pv_ptr newp ;
	int t, v ;
	newp = clause (p, &t, & v) ;
	system ((**p).name) ;
	return (newp) ;
}

/* sleep interpreter for n sec ( or n ticks if -ve) */

pv_ptr isleep (p) 
register pv_ptr p ;
{
	int t, n ;
	p = clause (p, &t, &n) ;
	sleep (n) ;
	return (p) ;
}

/* wait until a character is typed. Ctrl-d terminates current  line */

pv_ptr ipause (p) 
register pv_ptr p ;
{
	register int c ;
	if ((c = getchar()) == EOF) abrt = IABORT ;
	return (p) ;
}
 
pv_ptr ibeep (p) 
register pv_ptr p ;
{
	register int c ;
	beep();
	return (p) ;
}
 

pv_ptr date (p)
register pv_ptr p ;
{
	system("date") ;
	return (p) ;
}

pv_ptr prt (p)
register pv_ptr p ;
{
	int typ, val ;
	register pv_ptr newp ;
	newp = clause(p, &typ, &val);
	printf ("%d\n",val) ;
	return (newp) ;
}

#include "lcmds.c"
#include "symtab.h"
